// FullAccess
resource "azurerm_role_definition" "storsimple_fullaccess_definition" {
  name              = "storsimple-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.StorSimple/register/action",
      "Microsoft.StorSimple/managers/devices/updateSummary/read",
      "Microsoft.StorSimple/managers/devices/sendTestAlertEmail/action",
      "Microsoft.StorSimple/managers/devices/scanForUpdates/action",
      "Microsoft.StorSimple/managers/devices/download/action",
      "Microsoft.StorSimple/managers/devices/install/action",
      "Microsoft.StorSimple/managers/devices/read",
      "Microsoft.StorSimple/managers/devices/write",
      "Microsoft.StorSimple/managers/devices/delete",
      "Microsoft.StorSimple/managers/devices/deactivate/action",
      "Microsoft.StorSimple/managers/devices/failover/action",
      "Microsoft.StorSimple/managers/devices/publishSupportPackage/action",
      "Microsoft.StorSimple/managers/devices/authorizeForServiceEncryptionKeyRollover/action",
      "Microsoft.StorSimple/managers/devices/installUpdates/action",
      "Microsoft.StorSimple/managers/devices/listFailoverSets/action",
      "Microsoft.StorSimple/managers/devices/listFailoverTargets/action",
      "Microsoft.StorSimple/managers/devices/publicEncryptionKey/action",
      "Microsoft.StorSimple/managers/devices/timeSettings/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/write",
      "Microsoft.StorSimple/managers/devices/alertSettings/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/write",
      "Microsoft.StorSimple/managers/devices/networkSettings/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/write",
      "Microsoft.StorSimple/managers/devices/securitySettings/update/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/syncRemoteManagementCertificate/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/write",
      "Microsoft.StorSimple/managers/devices/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/metrics/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/write",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/backup/action",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/write",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/delete",
      "Microsoft.StorSimple/managers/alerts/read",
      "Microsoft.StorSimple/managers/clearAlerts/action",
      "Microsoft.StorSimple/managers/getEncryptionKey/action",
      "Microsoft.StorSimple/managers/read",
      "Microsoft.StorSimple/managers/delete",
      "Microsoft.StorSimple/managers/write",
      "Microsoft.StorSimple/managers/configureDevice/action",
      "Microsoft.StorSimple/managers/migrateClassicToResourceManager/action",
      "Microsoft.StorSimple/managers/listActivationKey/action",
      "Microsoft.StorSimple/managers/regenerateActivationKey/action",
      "Microsoft.StorSimple/managers/listPublicEncryptionKey/action",
      "Microsoft.StorSimple/managers/provisionCloudAppliance/action",
      "Microsoft.StorSimple/Managers/write",
      "Microsoft.StorSimple/Managers/read",
      "Microsoft.StorSimple/Managers/delete",
      "Microsoft.StorSimple/managers/storageAccountCredentials/write",
      "Microsoft.StorSimple/managers/storageAccountCredentials/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/delete",
      "Microsoft.StorSimple/managers/encryptionSettings/read",
      "Microsoft.StorSimple/managers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/metrics/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/write",
      "Microsoft.StorSimple/managers/devices/chapSettings/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/delete",
      "Microsoft.StorSimple/managers/devices/backups/read",
      "Microsoft.StorSimple/managers/devices/backups/delete",
      "Microsoft.StorSimple/managers/devices/backups/restore/action",
      "Microsoft.StorSimple/managers/devices/backups/elements/clone/action",
      "Microsoft.StorSimple/managers/storageDomains/read",
      "Microsoft.StorSimple/managers/storageDomains/write",
      "Microsoft.StorSimple/managers/storageDomains/delete",
      "Microsoft.StorSimple/managers/devices/jobs/read",
      "Microsoft.StorSimple/managers/devices/jobs/cancel/action",
      "Microsoft.StorSimple/managers/accessControlRecords/read",
      "Microsoft.StorSimple/managers/accessControlRecords/write",
      "Microsoft.StorSimple/managers/accessControlRecords/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/read",
      "Microsoft.StorSimple/managers/devices/fileservers/write",
      "Microsoft.StorSimple/managers/devices/fileservers/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/backup/action",
      "Microsoft.StorSimple/managers/devices/fileservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/delete",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/delete",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metrics/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/changeControllerPowerState/action",
      "Microsoft.StorSimple/managers/bandwidthSettings/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/write",
      "Microsoft.StorSimple/managers/bandwidthSettings/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/backup/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/import/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationStatus/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchConfirmMigrationStatus/action",
      "Microsoft.StorSimple/managers/cloudApplianceConfigurations/read",
      "Microsoft.StorSimple/managers/certificates/write",
      "Microsoft.StorSimple/Managers/certificates/write",
      "Microsoft.StorSimple/managers/extendedInformation/read",
      "Microsoft.StorSimple/managers/extendedInformation/write",
      "Microsoft.StorSimple/managers/extendedInformation/delete",
      "Microsoft.StorSimple/Managers/extendedInformation/read",
      "Microsoft.StorSimple/Managers/extendedInformation/write",
      "Microsoft.StorSimple/Managers/extendedInformation/delete",
      "Microsoft.StorSimple/managers/devices/failoverTargets/read",
      "Microsoft.StorSimple/managers/operationResults/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/operationResults/read",
      "Microsoft.StorSimple/managers/accessControlRecords/operationResults/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/operationResults/read",
      "Microsoft.StorSimple/managers/devices/operationResults/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/updates/operationResults/read",
      "Microsoft.StorSimple/managers/devices/failover/operationResults/read",
      "Microsoft.StorSimple/managers/storageDomains/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/elements/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/shares/read",
      "Microsoft.StorSimple/managers/devices/disks/read",
      "Microsoft.StorSimple/managers/iscsiservers/read",
      "Microsoft.StorSimple/managers/backups/read",
      "Microsoft.StorSimple/managers/jobs/read",
      "Microsoft.StorSimple/managers/fileservers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/operationResults/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/operationResults/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/operationResults/read",
      "Microsoft.StorSimple/managers/devices/jobs/operationResults/read",
      "Microsoft.StorSimple/managers/features/read",
      "Microsoft.StorSimple/managers/devices/volumes/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationEstimate/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationStatus/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigrationStatus/read",
      "Microsoft.StorSimple/managers/migrationSourceConfigurations/read",
      "Microsoft.StorSimple/operations/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "storsimple_readonly_definition" {
  name              = "storsimple-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.StorSimple/managers/devices/updateSummary/read",
      "Microsoft.StorSimple/managers/devices/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/read",
      "Microsoft.StorSimple/managers/devices/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/metrics/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/read",
      "Microsoft.StorSimple/managers/alerts/read",
      "Microsoft.StorSimple/managers/read",
      "Microsoft.StorSimple/Managers/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/read",
      "Microsoft.StorSimple/managers/encryptionSettings/read",
      "Microsoft.StorSimple/managers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/metrics/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/read",
      "Microsoft.StorSimple/managers/devices/backups/read",
      "Microsoft.StorSimple/managers/storageDomains/read",
      "Microsoft.StorSimple/managers/devices/jobs/read",
      "Microsoft.StorSimple/managers/accessControlRecords/read",
      "Microsoft.StorSimple/managers/devices/fileservers/read",
      "Microsoft.StorSimple/managers/devices/fileservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metrics/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/read",
      "Microsoft.StorSimple/managers/cloudApplianceConfigurations/read",
      "Microsoft.StorSimple/managers/extendedInformation/read",
      "Microsoft.StorSimple/Managers/extendedInformation/read",
      "Microsoft.StorSimple/managers/devices/failoverTargets/read",
      "Microsoft.StorSimple/managers/operationResults/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/operationResults/read",
      "Microsoft.StorSimple/managers/accessControlRecords/operationResults/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/operationResults/read",
      "Microsoft.StorSimple/managers/devices/operationResults/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/updates/operationResults/read",
      "Microsoft.StorSimple/managers/devices/failover/operationResults/read",
      "Microsoft.StorSimple/managers/storageDomains/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/elements/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/shares/read",
      "Microsoft.StorSimple/managers/devices/disks/read",
      "Microsoft.StorSimple/managers/iscsiservers/read",
      "Microsoft.StorSimple/managers/backups/read",
      "Microsoft.StorSimple/managers/jobs/read",
      "Microsoft.StorSimple/managers/fileservers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/operationResults/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/operationResults/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/operationResults/read",
      "Microsoft.StorSimple/managers/devices/jobs/operationResults/read",
      "Microsoft.StorSimple/managers/features/read",
      "Microsoft.StorSimple/managers/devices/volumes/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationEstimate/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationStatus/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigrationStatus/read",
      "Microsoft.StorSimple/managers/migrationSourceConfigurations/read",
      "Microsoft.StorSimple/operations/read",
    ]

    not_actions = [
      "Microsoft.StorSimple/register/action",
      "Microsoft.StorSimple/managers/devices/sendTestAlertEmail/action",
      "Microsoft.StorSimple/managers/devices/scanForUpdates/action",
      "Microsoft.StorSimple/managers/devices/download/action",
      "Microsoft.StorSimple/managers/devices/install/action",
      "Microsoft.StorSimple/managers/devices/write",
      "Microsoft.StorSimple/managers/devices/delete",
      "Microsoft.StorSimple/managers/devices/deactivate/action",
      "Microsoft.StorSimple/managers/devices/failover/action",
      "Microsoft.StorSimple/managers/devices/publishSupportPackage/action",
      "Microsoft.StorSimple/managers/devices/authorizeForServiceEncryptionKeyRollover/action",
      "Microsoft.StorSimple/managers/devices/installUpdates/action",
      "Microsoft.StorSimple/managers/devices/listFailoverSets/action",
      "Microsoft.StorSimple/managers/devices/listFailoverTargets/action",
      "Microsoft.StorSimple/managers/devices/publicEncryptionKey/action",
      "Microsoft.StorSimple/managers/devices/timeSettings/write",
      "Microsoft.StorSimple/managers/devices/alertSettings/write",
      "Microsoft.StorSimple/managers/devices/networkSettings/write",
      "Microsoft.StorSimple/managers/devices/securitySettings/update/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/syncRemoteManagementCertificate/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/write",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/write",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/backup/action",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/write",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/delete",
      "Microsoft.StorSimple/managers/clearAlerts/action",
      "Microsoft.StorSimple/managers/getEncryptionKey/action",
      "Microsoft.StorSimple/managers/delete",
      "Microsoft.StorSimple/managers/write",
      "Microsoft.StorSimple/managers/configureDevice/action",
      "Microsoft.StorSimple/managers/migrateClassicToResourceManager/action",
      "Microsoft.StorSimple/managers/listActivationKey/action",
      "Microsoft.StorSimple/managers/regenerateActivationKey/action",
      "Microsoft.StorSimple/managers/listPublicEncryptionKey/action",
      "Microsoft.StorSimple/managers/provisionCloudAppliance/action",
      "Microsoft.StorSimple/Managers/write",
      "Microsoft.StorSimple/Managers/delete",
      "Microsoft.StorSimple/managers/storageAccountCredentials/write",
      "Microsoft.StorSimple/managers/storageAccountCredentials/delete",
      "Microsoft.StorSimple/managers/devices/chapSettings/write",
      "Microsoft.StorSimple/managers/devices/chapSettings/delete",
      "Microsoft.StorSimple/managers/devices/backups/delete",
      "Microsoft.StorSimple/managers/devices/backups/restore/action",
      "Microsoft.StorSimple/managers/devices/backups/elements/clone/action",
      "Microsoft.StorSimple/managers/storageDomains/write",
      "Microsoft.StorSimple/managers/storageDomains/delete",
      "Microsoft.StorSimple/managers/devices/jobs/cancel/action",
      "Microsoft.StorSimple/managers/accessControlRecords/write",
      "Microsoft.StorSimple/managers/accessControlRecords/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/write",
      "Microsoft.StorSimple/managers/devices/fileservers/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/backup/action",
      "Microsoft.StorSimple/managers/devices/volumeContainers/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/delete",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/delete",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/changeControllerPowerState/action",
      "Microsoft.StorSimple/managers/bandwidthSettings/write",
      "Microsoft.StorSimple/managers/bandwidthSettings/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/backup/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/import/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationStatus/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchConfirmMigrationStatus/action",
      "Microsoft.StorSimple/managers/certificates/write",
      "Microsoft.StorSimple/Managers/certificates/write",
      "Microsoft.StorSimple/managers/extendedInformation/write",
      "Microsoft.StorSimple/managers/extendedInformation/delete",
      "Microsoft.StorSimple/Managers/extendedInformation/write",
      "Microsoft.StorSimple/Managers/extendedInformation/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "storsimple_noaccess_definition" {
  name              = "storsimple-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.StorSimple/register/action",
      "Microsoft.StorSimple/managers/devices/updateSummary/read",
      "Microsoft.StorSimple/managers/devices/sendTestAlertEmail/action",
      "Microsoft.StorSimple/managers/devices/scanForUpdates/action",
      "Microsoft.StorSimple/managers/devices/download/action",
      "Microsoft.StorSimple/managers/devices/install/action",
      "Microsoft.StorSimple/managers/devices/read",
      "Microsoft.StorSimple/managers/devices/write",
      "Microsoft.StorSimple/managers/devices/delete",
      "Microsoft.StorSimple/managers/devices/deactivate/action",
      "Microsoft.StorSimple/managers/devices/failover/action",
      "Microsoft.StorSimple/managers/devices/publishSupportPackage/action",
      "Microsoft.StorSimple/managers/devices/authorizeForServiceEncryptionKeyRollover/action",
      "Microsoft.StorSimple/managers/devices/installUpdates/action",
      "Microsoft.StorSimple/managers/devices/listFailoverSets/action",
      "Microsoft.StorSimple/managers/devices/listFailoverTargets/action",
      "Microsoft.StorSimple/managers/devices/publicEncryptionKey/action",
      "Microsoft.StorSimple/managers/devices/timeSettings/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/write",
      "Microsoft.StorSimple/managers/devices/alertSettings/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/write",
      "Microsoft.StorSimple/managers/devices/networkSettings/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/write",
      "Microsoft.StorSimple/managers/devices/securitySettings/update/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/syncRemoteManagementCertificate/action",
      "Microsoft.StorSimple/managers/devices/securitySettings/write",
      "Microsoft.StorSimple/managers/devices/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/metrics/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/write",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/metrics/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/write",
      "Microsoft.StorSimple/managers/devices/iscsiservers/delete",
      "Microsoft.StorSimple/managers/devices/iscsiservers/backup/action",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/write",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/delete",
      "Microsoft.StorSimple/managers/alerts/read",
      "Microsoft.StorSimple/managers/clearAlerts/action",
      "Microsoft.StorSimple/managers/getEncryptionKey/action",
      "Microsoft.StorSimple/managers/read",
      "Microsoft.StorSimple/managers/delete",
      "Microsoft.StorSimple/managers/write",
      "Microsoft.StorSimple/managers/configureDevice/action",
      "Microsoft.StorSimple/managers/migrateClassicToResourceManager/action",
      "Microsoft.StorSimple/managers/listActivationKey/action",
      "Microsoft.StorSimple/managers/regenerateActivationKey/action",
      "Microsoft.StorSimple/managers/listPublicEncryptionKey/action",
      "Microsoft.StorSimple/managers/provisionCloudAppliance/action",
      "Microsoft.StorSimple/Managers/write",
      "Microsoft.StorSimple/Managers/read",
      "Microsoft.StorSimple/Managers/delete",
      "Microsoft.StorSimple/managers/storageAccountCredentials/write",
      "Microsoft.StorSimple/managers/storageAccountCredentials/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/delete",
      "Microsoft.StorSimple/managers/encryptionSettings/read",
      "Microsoft.StorSimple/managers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/metrics/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/write",
      "Microsoft.StorSimple/managers/devices/chapSettings/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/delete",
      "Microsoft.StorSimple/managers/devices/backups/read",
      "Microsoft.StorSimple/managers/devices/backups/delete",
      "Microsoft.StorSimple/managers/devices/backups/restore/action",
      "Microsoft.StorSimple/managers/devices/backups/elements/clone/action",
      "Microsoft.StorSimple/managers/storageDomains/read",
      "Microsoft.StorSimple/managers/storageDomains/write",
      "Microsoft.StorSimple/managers/storageDomains/delete",
      "Microsoft.StorSimple/managers/devices/jobs/read",
      "Microsoft.StorSimple/managers/devices/jobs/cancel/action",
      "Microsoft.StorSimple/managers/accessControlRecords/read",
      "Microsoft.StorSimple/managers/accessControlRecords/write",
      "Microsoft.StorSimple/managers/accessControlRecords/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/read",
      "Microsoft.StorSimple/managers/devices/fileservers/write",
      "Microsoft.StorSimple/managers/devices/fileservers/delete",
      "Microsoft.StorSimple/managers/devices/fileservers/backup/action",
      "Microsoft.StorSimple/managers/devices/fileservers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/fileservers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/delete",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/metrics/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/write",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/delete",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metricsDefinitions/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/metrics/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/changeControllerPowerState/action",
      "Microsoft.StorSimple/managers/bandwidthSettings/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/write",
      "Microsoft.StorSimple/managers/bandwidthSettings/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/write",
      "Microsoft.StorSimple/managers/devices/backupPolicies/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/delete",
      "Microsoft.StorSimple/managers/devices/backupPolicies/backup/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/import/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/startMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigration/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationEstimate/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchMigrationStatus/action",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/fetchConfirmMigrationStatus/action",
      "Microsoft.StorSimple/managers/cloudApplianceConfigurations/read",
      "Microsoft.StorSimple/managers/certificates/write",
      "Microsoft.StorSimple/Managers/certificates/write",
      "Microsoft.StorSimple/managers/extendedInformation/read",
      "Microsoft.StorSimple/managers/extendedInformation/write",
      "Microsoft.StorSimple/managers/extendedInformation/delete",
      "Microsoft.StorSimple/Managers/extendedInformation/read",
      "Microsoft.StorSimple/Managers/extendedInformation/write",
      "Microsoft.StorSimple/Managers/extendedInformation/delete",
      "Microsoft.StorSimple/managers/devices/failoverTargets/read",
      "Microsoft.StorSimple/managers/operationResults/read",
      "Microsoft.StorSimple/managers/storageAccountCredentials/operationResults/read",
      "Microsoft.StorSimple/managers/accessControlRecords/operationResults/read",
      "Microsoft.StorSimple/managers/devices/alertSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/securitySettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/iscsiservers/disks/operationResults/read",
      "Microsoft.StorSimple/managers/devices/operationResults/read",
      "Microsoft.StorSimple/managers/devices/chapSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/fileservers/shares/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupScheduleGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/updates/operationResults/read",
      "Microsoft.StorSimple/managers/devices/failover/operationResults/read",
      "Microsoft.StorSimple/managers/storageDomains/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/elements/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/shares/read",
      "Microsoft.StorSimple/managers/devices/disks/read",
      "Microsoft.StorSimple/managers/iscsiservers/read",
      "Microsoft.StorSimple/managers/backups/read",
      "Microsoft.StorSimple/managers/jobs/read",
      "Microsoft.StorSimple/managers/fileservers/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/operationResults/read",
      "Microsoft.StorSimple/managers/devices/volumeContainers/volumes/operationResults/read",
      "Microsoft.StorSimple/managers/bandwidthSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/timeSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/networkSettings/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/operationResults/read",
      "Microsoft.StorSimple/managers/devices/backupPolicies/schedules/operationResults/read",
      "Microsoft.StorSimple/managers/devices/hardwareComponentGroups/operationResults/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/operationResults/read",
      "Microsoft.StorSimple/managers/devices/jobs/operationResults/read",
      "Microsoft.StorSimple/managers/features/read",
      "Microsoft.StorSimple/managers/devices/volumes/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationEstimate/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/migrationStatus/read",
      "Microsoft.StorSimple/managers/devices/migrationSourceConfigurations/confirmMigrationStatus/read",
      "Microsoft.StorSimple/managers/migrationSourceConfigurations/read",
      "Microsoft.StorSimple/operations/read",
    ]
  }
}
